Index: tests/regression/Atoms/TranslationToOrigin/post/test-shifted-weighted.xyz
===================================================================
--- tests/regression/Atoms/TranslationToOrigin/post/test-shifted-weighted.xyz	(revision 5c8807e908af52740778a67bac4173280b6d141b)
+++ tests/regression/Atoms/TranslationToOrigin/post/test-shifted-weighted.xyz	(revision 5c8807e908af52740778a67bac4173280b6d141b)
@@ -0,0 +1,5 @@
+3
+	Created for TranslateToOrigin regression test
+H	1	-0.5	0
+H	-1	0.5	0
+H	0	0.5	1
Index: tests/regression/Atoms/TranslationToOrigin/post/test-shifted.xyz
===================================================================
--- tests/regression/Atoms/TranslationToOrigin/post/test-shifted.xyz	(revision 5c8807e908af52740778a67bac4173280b6d141b)
+++ tests/regression/Atoms/TranslationToOrigin/post/test-shifted.xyz	(revision 5c8807e908af52740778a67bac4173280b6d141b)
@@ -0,0 +1,5 @@
+3
+	Created for TranslateToOrigin regression test
+H	0	0	0
+H	-2	1	0
+H	-1	1	1
Index: tests/regression/Atoms/TranslationToOrigin/post/test.xyz
===================================================================
--- tests/regression/Atoms/TranslationToOrigin/post/test.xyz	(revision 5c8807e908af52740778a67bac4173280b6d141b)
+++ tests/regression/Atoms/TranslationToOrigin/post/test.xyz	(revision 5c8807e908af52740778a67bac4173280b6d141b)
@@ -0,0 +1,5 @@
+3
+	Created for TranslateToOrigin regression test
+H	1	-1	0
+H	-1	0	0
+H	0	0	1
Index: tests/regression/Atoms/TranslationToOrigin/pre/test.xyz
===================================================================
--- tests/regression/Atoms/TranslationToOrigin/pre/test.xyz	(revision 5c8807e908af52740778a67bac4173280b6d141b)
+++ tests/regression/Atoms/TranslationToOrigin/pre/test.xyz	(revision 5c8807e908af52740778a67bac4173280b6d141b)
@@ -0,0 +1,5 @@
+3
+	Created for TranslateToOrigin regression test
+H	1.	-1.	0
+H	-1.	0.	0
+H	0.	0.	1.
Index: tests/regression/Atoms/TranslationToOrigin/testsuite-atoms-translation-to-origin.at
===================================================================
--- tests/regression/Atoms/TranslationToOrigin/testsuite-atoms-translation-to-origin.at	(revision 5c8807e908af52740778a67bac4173280b6d141b)
+++ tests/regression/Atoms/TranslationToOrigin/testsuite-atoms-translation-to-origin.at	(revision 5c8807e908af52740778a67bac4173280b6d141b)
@@ -0,0 +1,65 @@
+#
+#    MoleCuilder - creates and alters molecular systems
+#    Copyright (C) 2008-2012 University of Bonn
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+### translation
+
+AT_SETUP([Atoms - Translation to origin])
+AT_KEYWORDS([atoms translate-to-origin])
+
+file=test.xyz
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/TranslationToOrigin/pre/test.xyz $file], 0)
+AT_CHECK([chmod u+w $file], 0)
+AT_CHECK([../../molecuilder -i $file --select-atom-by-id 0 --translate-to-origin], 0, [stdout], [stderr])
+AT_CHECK([diff -I '.*Created.*' $file ${abs_top_srcdir}/tests/regression/Atoms/TranslationToOrigin/post/test-shifted.xyz], 0, [ignore], [ignore])
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/TranslationToOrigin/pre/test.xyz $file], 0)
+AT_CHECK([chmod u+w $file], 0)
+AT_CHECK([../../molecuilder -i $file --select-atom-by-id 0 1 --translate-to-origin], 0, [stdout], [stderr])
+AT_CHECK([diff -I '.*Created.*' $file ${abs_top_srcdir}/tests/regression/Atoms/TranslationToOrigin/post/test-shifted-weighted.xyz], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Atoms - Translation to origin with Undo])
+AT_KEYWORDS([atoms translate-to-origin undo])
+
+file=test.xyz
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/TranslationToOrigin/pre/test.xyz $file], 0)
+AT_CHECK([chmod u+w $file], 0)
+AT_CHECK([../../molecuilder -i $file --select-atom-by-id 0 --translate-to-origin --undo], 0, [stdout], [stderr])
+AT_CHECK([diff -I '.*Created.*' $file ${abs_top_srcdir}/tests/regression/Atoms/TranslationToOrigin/post/test.xyz], 0, [ignore], [ignore])
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/TranslationToOrigin/pre/test.xyz $file], 0)
+AT_CHECK([chmod u+w $file], 0)
+AT_CHECK([../../molecuilder -i $file --select-atom-by-id 0 1 --translate-to-origin --undo], 0, [stdout], [stderr])
+AT_CHECK([diff -I '.*Created.*' $file ${abs_top_srcdir}/tests/regression/Atoms/TranslationToOrigin/post/test.xyz], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Atoms - Translation to origin with Redo])
+AT_KEYWORDS([atoms translate-to-origin redo])
+
+file=test.xyz
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/TranslationToOrigin/pre/test.xyz $file], 0)
+AT_CHECK([chmod u+w $file], 0)
+AT_CHECK([../../molecuilder -i $file --select-atom-by-id 0 --translate-to-origin --undo --redo], 0, [stdout], [stderr])
+AT_CHECK([diff -I '.*Created.*' $file ${abs_top_srcdir}/tests/regression/Atoms/TranslationToOrigin/post/test-shifted.xyz], 0, [ignore], [ignore])
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Atoms/TranslationToOrigin/pre/test.xyz $file], 0)
+AT_CHECK([chmod u+w $file], 0)
+AT_CHECK([../../molecuilder -i $file --select-atom-by-id 0 1 --translate-to-origin --undo --redo], 0, [stdout], [stderr])
+AT_CHECK([diff -I '.*Created.*' $file ${abs_top_srcdir}/tests/regression/Atoms/TranslationToOrigin/post/test-shifted-weighted.xyz], 0, [ignore], [ignore])
+
+AT_CLEANUP
Index: tests/regression/Atoms/testsuite-atoms.at
===================================================================
--- tests/regression/Atoms/testsuite-atoms.at	(revision bbf6dcd010a0439f2e1a441678550e5a56e1cf30)
+++ tests/regression/Atoms/testsuite-atoms.at	(revision 5c8807e908af52740778a67bac4173280b6d141b)
@@ -39,4 +39,7 @@
 m4_include([Atoms/Translation/testsuite-atoms-translation.at])
 
+# translate to origin
+m4_include([Atoms/TranslationToOrigin/testsuite-atoms-translation-to-origin.at])
+
 # mirror atoms
 m4_include([Atoms/Mirror/testsuite-atoms-mirror.at])
